TSAD_UNIVARIATE = ["ACSF1", "Adiac", "AllGestureWiimoteX", "AllGestureWiimoteY", "AllGestureWiimoteZ", "ArrowHead", "BME", "Beef", "BeetleFly", "BirdChicken", "CBF", "Car", "Chinatown", "ChlorineConcentration", "CinCECGTorso", "Coffee", "Computers", "CricketX", "CricketY", "CricketZ", "Crop", "DiatomSizeReduction", "DistalPhalanxOutlineAgeGroup", "DistalPhalanxOutlineCorrect", "DistalPhalanxTW", "DodgerLoopDay", "DodgerLoopGame", "DodgerLoopWeekend", "ECG200", "ECG5000", "ECGFiveDays", "EOGHorizontalSignal", "EOGVerticalSignal", "Earthquakes", "ElectricDevices", "EthanolLevel", "FaceAll", "FaceFour", "FacesUCR", "FiftyWords", "Fish", "FordA", "FordB", "FreezerRegularTrain", "FreezerSmallTrain", "Fungi", "GestureMidAirD1", "GestureMidAirD2", "GestureMidAirD3", "GesturePebbleZ1", "GesturePebbleZ2", "GunPoint", "GunPointAgeSpan", "GunPointMaleVersusFemale", "GunPointOldVersusYoung", "Ham", "HandOutlines", "Haptics", "Herring", "HouseTwenty", "InlineSkate", "InsectEPGRegularTrain", "InsectEPGSmallTrain", "InsectWingbeatSound", "ItalyPowerDemand", "LargeKitchenAppliances", "Lightning2", "Lightning7", "Mallat", "Meat", "MelbournePedestrian", "MiddlePhalanxOutlineAgeGroup", "MiddlePhalanxOutlineCorrect", "MiddlePhalanxTW", "MixedShapesRegularTrain", "MixedShapesSmallTrain", "MoteStrain", "NonInvasiveFetalECGThorax1", "NonInvasiveFetalECGThorax2", "OSULeaf", "OliveOil", "PLAID", "PhalangesOutlinesCorrect", "Phoneme", "PickupGestureWiimoteZ", "PigAirwayPressure", "PigArtPressure", "PigCVP", "Plane", "PowerCons", "ProximalPhalanxOutlineAgeGroup", "ProximalPhalanxOutlineCorrect", "ProximalPhalanxTW", "RefrigerationDevices", "Rock", "ScreenType", "SemgHandGenderCh2", "SemgHandMovementCh2", "SemgHandSubjectCh2", "ShakeGestureWiimoteZ", "ShapeletSim", "ShapesAll", "SmallKitchenAppliances", "SmoothSubspace", "SonyAIBORobotSurface1", "SonyAIBORobotSurface2", "StarLightCurves", "Strawberry", "SwedishLeaf", "Symbols", "SyntheticControl", "ToeSegmentation1", "ToeSegmentation2", "Trace", "TwoLeadECG", "TwoPatterns", "UMD", "UWaveGestureLibraryAll", "UWaveGestureLibraryX", "UWaveGestureLibraryY", "UWaveGestureLibraryZ", "Wafer", "Wine", "WordSynonyms", "Worms", "WormsTwoClass", "Yoga"]

# the default anomaly class is defined as: the lexically first class with the least occurences
# Example: Dict([("class2", 10), ("class1", 10), ("class3": 20))]) -> "class1"
TSAD_UNIVARIATE_DEFAULTS = Dict("ECG5000" => "5", "FordA" => "1", "DodgerLoopGame" => "2", "Trace" => "1", "DodgerLoopDay" => "3", "CricketZ" => "1", "GunPointOldVersusYoung" => "1", "HandOutlines" => "0", "Ham" => "1", "CricketY" => "1", "DiatomSizeReduction" => "1", "SmoothSubspace" => "1", "TwoPatterns" => "4", "Phoneme" => "39", "GunPointMaleVersusFemale" => "2", "SmallKitchenAppliances" => "1", "UWaveGestureLibraryZ" => "1", "Strawberry" => "1", "Mallat" => "1", "Fish" => "5", "GestureMidAirD3" => "1", "ShakeGestureWiimoteZ" => "1", "FreezerRegularTrain" => "1", "FaceFour" => "1", "WordSynonyms" => "25", "TwoLeadECG" => "1", "Meat" => "1", "BirdChicken" => "1", "EOGVerticalSignal" => "12", "ProximalPhalanxOutlineAgeGroup" => "1", "SwedishLeaf" => "1", "UMD" => "1", "MiddlePhalanxTW" => "7", "EOGHorizontalSignal" => "12", "GestureMidAirD1" => "1", "GesturePebbleZ2" => "2", "NonInvasiveFetalECGThorax2" => "11", "ScreenType" => "1", "BeetleFly" => "1", "SyntheticControl" => "1", "WormsTwoClass" => "1", "Yoga" => "1", "AllGestureWiimoteZ" => "1", "DistalPhalanxOutlineCorrect" => "0", "Adiac" => "1", "FacesUCR" => "11", "BME" => "1", "InsectEPGSmallTrain" => "3", "Coffee" => "1", "StarLightCurves" => "1", "SemgHandGenderCh2" => "2", "PigCVP" => "1", "Wine" => "2", "PickupGestureWiimoteZ" => "1", "InlineSkate" => "1", "MixedShapesRegularTrain" => "5", "MixedShapesSmallTrain" => "5", "Wafer" => "-1", "UWaveGestureLibraryX" => "1", "AllGestureWiimoteY" => "1", "CBF" => "1", "Crop" => "1", "Earthquakes" => "1", "GunPointAgeSpan" => "2", "SonyAIBORobotSurface2" => "1", "Worms" => "5", "ECGFiveDays" => "1", "PhalangesOutlinesCorrect" => "0", "Haptics" => "1", "InsectWingbeatSound" => "1", "ECG200" => "-1", "OliveOil" => "3", "ShapesAll" => "1", "Chinatown" => "1", "Beef" => "2", "SemgHandMovementCh2" => "1", "FreezerSmallTrain" => "1", "InsectEPGRegularTrain" => "3", "Rock" => "3", "GunPoint" => "1", "Symbols" => "2", "Lightning7" => "2", "PowerCons" => "1", "Computers" => "1", "GestureMidAirD2" => "1", "HouseTwenty" => "2", "ArrowHead" => "1", "OSULeaf" => "6", "ACSF1" => "0", "CricketX" => "1", "Plane" => "1", "FordB" => "1", "FaceAll" => "11", "ToeSegmentation2" => "1", "CinCECGTorso" => "1", "MiddlePhalanxOutlineAgeGroup" => "1", "ProximalPhalanxOutlineCorrect" => "0", "AllGestureWiimoteX" => "1", "SemgHandSubjectCh2" => "1", "UWaveGestureLibraryAll" => "1", "Fungi" => "1", "Herring" => "2", "DodgerLoopWeekend" => "2", "PigAirwayPressure" => "1", "ProximalPhalanxTW" => "3", "PLAID" => "10", "ChlorineConcentration" => "1", "PigArtPressure" => "1", "FiftyWords" => "49", "EthanolLevel" => "2", "MiddlePhalanxOutlineCorrect" => "0", "ElectricDevices" => "6", "UWaveGestureLibraryY" => "1", "SonyAIBORobotSurface1" => "2", "DistalPhalanxOutlineAgeGroup" => "1", "GesturePebbleZ1" => "2", "ToeSegmentation1" => "1", "DistalPhalanxTW" => "7", "LargeKitchenAppliances" => "1", "NonInvasiveFetalECGThorax1" => "11", "Car" => "1", "RefrigerationDevices" => "1", "ItalyPowerDemand" => "1", "MelbournePedestrian" => "8", "ShapeletSim" => "0", "MoteStrain" => "2", "Lightning2" => "-1")

# a dictionary mapping the dataset names to their respective class counts
TSAD_UNIVARIATE_CLASSES = Dict{String, Dict}("ECG5000" => Dict("4" => 194, "1" => 2919, "5" => 24, "2" => 1767, "3" => 96), "FordA" => Dict("1" => 2394, "-1" => 2527), "DodgerLoopGame" => Dict("1" => 82, "2" => 76), "Trace" => Dict("4" => 50, "1" => 50, "2" => 50, "3" => 50), "DodgerLoopDay" => Dict("4" => 22, "1" => 24, "5" => 24, "2" => 21, "6" => 25, "7" => 22, "3" => 20), "CricketZ" => Dict("4" => 65, "1" => 65, "12" => 65, "2" => 65, "6" => 65, "7" => 65, "11" => 65, "8" => 65, "10" => 65, "5" => 65, "9" => 65, "3" => 65), "GunPointOldVersusYoung" => Dict("1" => 215, "2" => 236), "HandOutlines" => Dict("1" => 874, "0" => 494), "Ham" => Dict("1" => 103, "2" => 111), "CricketY" => Dict("4" => 65, "1" => 65, "12" => 65, "2" => 65, "6" => 65, "7" => 65, "11" => 65, "8" => 65, "10" => 65, "5" => 65, 
"9" => 65, "3" => 65), "DiatomSizeReduction" => Dict("4" => 91, "1" => 34, "2" => 98, "3" => 99), "SmoothSubspace" => Dict("1" => 100, "2" => 100, "3" => 100), "TwoPatterns" => Dict("4" => 1201, "1" => 1306, "2" => 1248, "3" => 1245), "Phoneme" => Dict("24" => 22, "29" => 123, "1" => 42, "12" => 68, "32" => 9, "20" => 100, "4" => 26, "2" => 54, "25" => 32, "6" => 33, "23" => 149, "22" => 71, "11" => 66, "35" => 28, "13" => 41, "15" => 26, "27" => 64, "31" => 145, "5" => 9, "33" => 6, "28" => 113, "16" => 17, "14" => 38, "39" => 2, "21" => 125, "38" => 24, "7" => 47, "34" => 23, "8" => 12, "36" => 20, "26" => 4, "17" => 109, "10" => 3, "19" => 18, "37" => 14, "18" => 83, "9" => 78, "30" => 28, "3" => 238), "GunPointMaleVersusFemale" => Dict("1" => 237, "2" => 214), "SmallKitchenAppliances" => Dict("1" => 250, "2" => 250, "3" => 250), "UWaveGestureLibraryZ" => Dict("8" => 560, "4" => 560, "1" => 559, "5" => 559, "2" => 560, "6" => 559, "7" => 559, "3" => 560), "Strawberry" => Dict("1" => 351, "2" => 632), "Mallat" => Dict("8" => 300, "4" => 300, "1" => 300, "5" => 300, "2" => 300, "6" => 300, "7" => 300, "3" => 300), "Fish" => Dict("4" => 50, "1" => 50, "5" => 49, "2" => 50, "6" => 50, "7" => 49, "3" => 50), "GestureMidAirD3" => Dict("24" => 13, "4" => 13, "1" => 13, "12" => 13, "20" => 13, "2" => 13, "25" => 13, "6" => 13, "23" => 13, "22" => 13, "11" => 13, "13" => 13, "15" => 13, "5" => 13, "16" => 13, "14" => 13, "21" => 13, "7" => 13, "8" => 13, "26" => 13, "17" => 13, "10" => 13, "19" => 13, "18" => 13, "9" => 13, "3" => 13), "ShakeGestureWiimoteZ" => Dict("8" => 10, "4" => 10, "1" => 10, "10" => 10, "2" => 10, "5" => 10, "6" => 10, "7" => 10, "9" => 10, "3" => 10), "FreezerRegularTrain" => Dict("1" => 1498, "2" => 1500), "FaceFour" => Dict("4" => 27, "1" => 22, "2" => 34, "3" => 29), "WordSynonyms" => Dict("24" => 20, "4" => 115, "1" => 20, "12" => 44, "20" => 26, "2" => 200, "25" => 12, "6" => 72, "23" => 14, "22" => 23, "11" => 16, "13" => 16, "15" => 16, "5" => 18, "16" => 30, "14" => 39, "21" => 14, "7" => 18, "8" => 56, "17" => 14, "10" => 46, "19" => 14, "18" => 27, "9" => 16, "3" => 19), "TwoLeadECG" => Dict("1" => 581, "2" => 581), "Meat" => Dict("1" => 40, "2" => 40, "3" => 40), "BirdChicken" => Dict("1" => 20, "2" => 20), "EOGVerticalSignal" => Dict("4" => 60, "1" => 60, "12" => 59, "2" => 60, "6" => 61, "7" => 61, "11" => 61, "8" => 60, "10" => 60, "5" => 61, "9" => 61, "3" => 60), "ProximalPhalanxOutlineAgeGroup" => Dict("1" => 89, "2" => 226, "3" => 
288), "SwedishLeaf" => Dict("3" => 75, "4" => 75, "1" => 75, "12" => 75, "2" => 75, "6" => 75, "7" => 75, "11" => 75, "13" => 75, "8" => 75, "10" => 75, "15" => 75, "5" => 75, "9" => 75, "14" => 75), "UMD" => Dict("1" => 60, "2" => 60, "3" => 60), "MiddlePhalanxTW" => Dict("8" => 200, "4" => 128, "5" => 66, "6" => 41, "7" => 34, "3" => 82), "EOGHorizontalSignal" => Dict("4" => 60, "1" => 60, "12" => 59, "2" => 60, "6" => 61, "7" => 61, "11" => 61, "8" => 60, "10" => 
60, "5" => 61, "9" => 61, "3" => 60), "GestureMidAirD1" => Dict("24" => 13, "4" => 13, "1" => 13, "12" => 13, "20" => 13, "2" => 13, "25" => 13, "6" => 13, "23" => 13, "22" => 13, "11" => 13, "13" => 13, "15" => 13, "5" => 13, "16" => 13, "14" => 13, "21" => 13, "7" => 13, "8" => 13, "26" => 13, "17" => 13, "10" 
=> 13, "19" => 13, "18" => 13, "9" => 13, "3" => 13), "GesturePebbleZ2" => Dict("4" => 53, "1" => 49, "5" => 52, "2" => 45, "6" => 51, "3" => 54), "NonInvasiveFetalECGThorax2" => Dict("24" => 87, "29" => 96, "1" => 84, "12" => 90, "32" => 90, "20" => 90, "4" => 85, "2" => 91, "25" => 90, "6" => 94, "23" => 87, "22" => 86, "11" => 75, "35" => 94, "13" => 97, "41" => 93, "15" => 98, "27" => 89, "31" => 94, "42" => 93, "33" => 85, "28" => 85, "16" => 95, "5" => 96, "14" => 89, "39" => 90, "40" => 91, "21" => 89, "38" => 91, "7" => 93, "34" => 94, "8" => 91, "36" => 91, "26" => 78, "17" => 85, "10" => 92, "19" => 88, "37" => 87, "18" => 91, "9" => 88, "30" => 86, "3" => 87), "ScreenType" => Dict("1" => 250, "2" => 250, "3" => 250), "BeetleFly" => Dict("1" => 20, "2" => 20), "SyntheticControl" => Dict("4" => 100, "1" => 100, "5" => 100, "2" => 100, "6" => 100, "3" => 100), "WormsTwoClass" => Dict("1" => 109, "2" => 149), "Yoga" => Dict("1" => 1530, "2" => 1770), "AllGestureWiimoteZ" => Dict("8" => 100, "4" => 100, "1" => 100, "10" => 100, "2" => 100, "5" => 100, "6" => 100, "7" => 100, "9" => 100, "3" => 100), "DistalPhalanxOutlineCorrect" => Dict("1" => 537, "0" => 337), "Adiac" => Dict("24" => 23, "29" => 20, "1" => 20, "12" => 26, "32" => 20, "20" => 21, "4" => 20, "2" => 23, "25" => 29, "6" => 20, "23" => 20, "22" => 20, "11" => 20, "35" => 20, "13" => 20, "15" => 21, "27" => 20, "31" => 20, "5" => 20, "33" => 20, "28" => 20, "16" => 20, "14" => 20, "21" => 20, "7" => 20, "34" => 20, "8" => 25, "36" => 25, "26" => 20, "17" => 20, "10" => 20, "19" => 26, "37" => 20, "18" => 22, "9" => 20, "30" => 20, "3" => 20), "FacesUCR" => Dict("3" => 176, "4" => 171, "1" => 112, "12" => 106, "2" => 178, "6" => 187, "7" => 149, "11" => 48, "13" => 327, "8" => 273, "10" => 135, "5" => 176, "9" => 140, "14" => 72), "BME" => Dict("1" => 60, "2" => 60, "3" => 60), "InsectEPGSmallTrain" => Dict("1" => 95, "2" => 126, "3" => 45), "Coffee" => Dict("1" => 27, "0" => 29), "StarLightCurves" => Dict("1" => 1329, "2" => 2580, "3" => 
5327), "SemgHandGenderCh2" => Dict("1" => 540, "2" => 360), "PigCVP" => Dict("32" => 6, "29" => 6, "1" => 6, "12" => 6, "9" => 6, "20" => 6, "2" => 6, "6" => 6, "41" => 6, "51" => 6, "27" => 6, "42" => 6, "33" => 6, "28" => 6, "50" => 6, "52" => 6, "14" => 6, "7" => 6, "8" => 6, "26" => 6, "10" => 6, "19" => 6, "24" => 6, "4" => 6, "25" => 6, "23" => 6, "22" => 6, "11" => 6, "35" => 6, "13" => 6, "49" => 6, "15" => 6, "31" => 6, "5" => 6, "43" => 6, "16" => 6, "39" => 6, "40" => 6, "21" => 6, "38" => 6, "46" => 6, "34" => 6, "44" => 6, "45" => 6, "36" => 6, "17" => 6, "37" => 6, "47" => 6, "18" => 6, "48" => 6, "30" => 6, "3" => 6), "Wine" => Dict("1" => 57, "2" => 54), "PickupGestureWiimoteZ" => Dict("8" => 10, "4" => 10, "1" => 10, "10" => 10, "2" => 10, "5" => 10, "6" => 
10, "7" => 10, "9" => 10, "3" => 10), "InlineSkate" => Dict("4" => 108, "1" => 62, "5" => 117, "2" => 100, "6" => 98, "7" => 62, "3" => 103), "MixedShapesRegularTrain" => Dict("4" => 681, "1" => 558, "5" => 414, "2" => 754, "3" => 518), "MixedShapesSmallTrain" => Dict("4" => 601, "1" => 478, "5" => 334, "2" => 674, "3" => 438), "Wafer" => Dict("1" => 6402, "-1" => 762), "UWaveGestureLibraryX" => Dict("8" => 560, "4" => 560, "1" => 559, "5" => 559, "2" => 560, "6" => 
559, "7" => 559, "3" => 560), "AllGestureWiimoteY" => Dict("8" => 100, "4" => 100, "1" => 100, "10" => 100, "2" => 100, "5" => 100, "6" => 100, "7" => 100, "9" => 100, "3" => 100), "CBF" => Dict("1" => 310, "2" => 310, "3" => 310), "Crop" => Dict("24" => 1000, "4" => 1000, "1" => 1000, "12" => 1000, "20" => 1000, "2" => 1000, "6" => 1000, "23" => 1000, "22" => 1000, "11" => 1000, "13" => 1000, "15" => 1000, "5" => 1000, "16" => 1000, "14" => 1000, "21" => 1000, "7" => 1000, "8" => 1000, "17" => 1000, "10" => 1000, "19" => 1000, "18" => 1000, "9" => 1000, "3" => 1000), "Earthquakes" => Dict("1" => 93, "0" => 368), "GunPointAgeSpan" => Dict("1" => 228, "2" => 223), "SonyAIBORobotSurface2" => Dict("1" => 376, "2" => 604), "Worms" => Dict("4" => 45, "1" => 109, "5" => 25, "2" => 44, "3" => 35), "ECGFiveDays" => Dict("1" => 442, "2" => 442), "PhalangesOutlinesCorrect" => Dict("1" => 1696, "0" => 960), "Haptics" => Dict("4" => 100, "1" => 78, "5" => 100, "2" => 92, "3" => 93), "InsectWingbeatSound" => Dict("4" => 200, "1" => 200, "2" => 200, "6" => 200, "7" => 200, "11" => 200, "8" => 200, "10" => 200, "5" => 200, "9" => 200, "3" => 200), "ECG200" => Dict("1" => 133, "-1" => 67), "OliveOil" => Dict("4" => 25, "1" => 10, "2" => 17, "3" => 8), 
"ShapesAll" => Dict("32" => 20, "29" => 20, "1" => 20, "12" => 20, "54" => 20, "20" => 20, "9" => 20, "2" => 20, "6" => 20, "41" => 20, "51" => 20, "53" => 20, "27" => 20, "42" => 20, "33" => 20, "28" => 20, "50" => 20, "52" => 20, "14" => 20, "7" => 20, "57" => 20, "8" => 20, "26" => 20, "10" => 20, "19" => 20, 
"60" => 20, "24" => 20, "4" => 20, "58" => 20, "25" => 20, "23" => 20, "22" => 20, "11" => 20, "35" => 20, "13" => 20, "49" => 20, "59" => 20, "15" => 20, "31" => 20, "5" => 20, "43" => 20, "16" => 20, "39" => 20, "40" => 20, "21" => 20, "38" => 20, "46" => 20, "34" => 20, "44" => 20, "45" => 20, "56" => 20, "55" => 20, "36" => 20, "17" => 20, "37" => 20, "47" => 20, "18" => 20, "48" => 20, "30" => 20, "3" => 20), "Chinatown" => Dict("1" => 104, "2" => 259), "Beef" => Dict("4" => 12, "5" => 12, "2" => 2, "3" => 12), "SemgHandMovementCh2" => Dict("4" => 150, "1" => 150, "5" => 150, "2" => 150, "6" => 150, "3" => 150), "FreezerSmallTrain" => Dict("1" => 1437, "2" => 1439), "InsectEPGRegularTrain" => Dict("1" => 111, "2" => 148, "3" => 52), "Rock" => Dict("4" => 19, "1" => 26, 
"2" => 14, "3" => 11), "GunPoint" => Dict("1" => 100, "2" => 100), "Symbols" => Dict("4" => 181, "1" => 181, "5" => 162, "2" => 162, "6" => 167, "3" => 167), "Lightning7" => Dict("4" => 15, "1" => 17, "5" => 38, "0" => 18, "2" => 14, "6" => 22, "3" => 19), "PowerCons" => Dict("1" => 180, "2" => 180), "Computers" 
=> Dict("1" => 250, "2" => 250), "GestureMidAirD2" => Dict("24" => 13, "4" => 13, "1" => 13, "12" => 13, "20" => 13, "2" => 13, "25" => 13, "6" => 13, "23" => 13, "22" => 13, "11" => 13, "13" => 13, "15" => 13, "5" => 13, "16" => 13, "14" => 13, "21" => 13, "7" => 13, "8" => 13, "26" => 13, "17" => 13, "10" => 13, "19" => 13, "18" => 13, "9" => 13, "3" => 13), "HouseTwenty" => Dict("1" => 87, "2" => 70), "ArrowHead" => Dict("1" => 65, "0" => 81, "2" => 65), "OSULeaf" => Dict("4" => 97, "1" => 66, "5" => 81, "2" => 84, "6" => 37, "3" => 75), "ACSF1" => Dict("8" => 20, "4" => 20, "1" => 20, "5" => 20, "0" => 20, "2" => 20, "6" => 20, "7" => 20, "9" => 20, "3" => 20), "CricketX" => Dict("4" => 65, "1" => 65, "12" => 65, "2" => 65, "6" => 65, "7" => 65, "11" => 65, "8" => 65, "10" => 65, "5" => 65, "9" => 65, "3" => 65), "Plane" => Dict("4" => 30, "1" => 30, "5" => 30, "2" => 30, "6" => 30, "7" => 30, "3" => 30), "FordB" => Dict("1" => 2185, "-1" => 2261), "FaceAll" => Dict("3" => 176, "4" => 171, "1" => 112, "12" => 106, "2" => 178, "6" => 187, "7" => 149, "11" => 48, "13" => 327, "8" 
=> 273, "10" => 135, "5" => 176, "9" => 140, "14" => 72), "ToeSegmentation2" => Dict("1" => 42, "0" => 124), "CinCECGTorso" => Dict("4" => 355, "1" => 355, "2" => 355, "3" => 355), "MiddlePhalanxOutlineAgeGroup" => Dict("1" => 92, "2" => 194, "3" => 266), "ProximalPhalanxOutlineCorrect" => Dict("1" => 603, "0" => 286), "AllGestureWiimoteX" => Dict("8" => 100, "4" => 100, "1" => 100, "10" => 100, "2" => 100, "5" => 100, "6" => 100, "7" => 100, "9" => 100, "3" => 100), "SemgHandSubjectCh2" => Dict("4" => 180, "1" => 180, "5" => 180, "2" => 180, "3" => 180), "UWaveGestureLibraryAll" => Dict("8" => 560, "4" => 560, "1" => 559, "5" => 559, "2" => 560, "6" => 559, "7" => 559, "3" => 560), "Fungi" => Dict("3" => 8, "4" => 20, "1" => 8, "12" => 16, "2" => 12, "6" => 12, "7" => 12, "11" => 8, "13" => 8, "8" => 8, "17" => 8, "10" => 8, "15" => 12, "5" => 8, "16" => 12, "18" => 16, "9" => 20, "14" => 8), "Herring" => Dict("1" => 77, "2" => 51), "DodgerLoopWeekend" => Dict("1" => 112, "2" => 46), "PigAirwayPressure" => Dict("32" => 6, "29" => 6, "1" => 6, "12" => 6, "9" => 6, "20" => 6, "2" => 
6, "6" => 6, "41" => 6, "51" => 6, "27" => 6, "42" => 6, "33" => 6, "28" => 6, "50" => 6, "52" => 6, "14" => 6, "7" => 6, "8" => 6, "26" => 6, "10" => 6, "19" => 6, "24" => 6, "4" => 6, "25" => 6, "23" => 6, "22" => 6, "11" => 6, "35" => 6, "13" => 6, "49" => 6, "15" => 6, "31" => 6, "5" => 6, "43" => 6, "16" => 
6, "39" => 6, "40" => 6, "21" => 6, "38" => 6, "46" => 6, "34" => 6, "44" => 6, "45" => 6, "36" => 6, "17" => 6, "37" => 6, "47" => 6, "18" => 6, "48" => 6, 
"30" => 6, "3" => 6), "ProximalPhalanxTW" => Dict("8" => 251, "4" => 176, "5" => 98, "6" => 30, "7" => 31, "3" => 17), "PLAID" => Dict("4" => 156, "1" => 175, "2" => 115, "6" => 114, "7" => 172, "8" => 139, "10" => 26, "0" => 66, "5" => 35, "9" => 38, "3" => 38), "ChlorineConcentration" => Dict("1" => 1000, "2" => 1000, "3" => 2307), "PigArtPressure" => Dict("32" => 6, "29" => 6, "1" => 6, "12" => 6, "9" => 6, "20" => 6, "2" => 6, "6" => 6, "41" => 6, "51" => 6, "27" => 6, "42" => 6, "33" => 6, "28" => 6, "50" => 6, "52" => 6, "14" => 6, "7" => 6, "8" => 6, "26" => 6, "10" => 6, "19" => 6, "24" => 6, "4" => 6, "25" => 6, "23" => 6, "22" => 6, "11" => 6, "35" => 6, "13" => 6, "49" => 6, "15" => 6, "31" => 6, "5" => 6, "43" => 6, "16" => 6, "39" => 6, "40" => 6, "21" => 6, "38" => 6, "46" => 6, "34" => 6, "44" => 6, "45" => 6, "36" => 6, "17" => 6, "37" => 6, "47" => 6, "18" => 6, "48" => 6, "30" => 6, "3" => 6), "FiftyWords" => Dict("32" => 9, "29" => 9, "1" => 109, "12" => 22, "9" => 23, "20" => 13, "2" => 91, "6" => 34, "41" => 7, "27" => 10, "42" => 7, "33" => 8, "28" => 9, "50" => 6, "14" => 18, "7" => 32, "8" => 24, "26" => 10, "10" => 22, "19" => 13, "24" => 10, "4" => 53, "25" => 10, "23" => 10, "22" => 11, "11" => 22, "35" => 8, 
"13" => 21, "49" => 6, "15" => 16, "31" => 9, "5" => 38, "43" => 7, "16" => 14, "39" => 8, "40" => 8, "21" => 12, "38" => 8, "46" => 7, "34" => 8, "44" => 7, "45" => 7, "36" => 8, "17" => 14, "37" => 8, "47" => 7, "18" => 13, "48" => 7, "30" => 9, "3" => 61), "EthanolLevel" => Dict("4" => 250, "1" => 252, "2" => 
250, "3" => 252), "MiddlePhalanxOutlineCorrect" => Dict("1" => 553, "0" => 336), "ElectricDevices" => Dict("4" => 2639, "1" => 1394, "5" => 4275, "2" => 4187, "6" => 1252, "7" => 1284, "3" => 1606), "UWaveGestureLibraryY" => Dict("8" => 560, "4" => 560, "1" => 559, "5" => 559, "2" => 560, "6" => 559, "7" => 559, 
"3" => 560), "SonyAIBORobotSurface1" => Dict("1" => 349, "2" => 272), "DistalPhalanxOutlineAgeGroup" => Dict("1" => 45, "2" => 170, "3" => 322), "GesturePebbleZ1" => Dict("4" => 53, "1" => 49, "5" => 52, "2" => 45, "6" => 51, "3" => 54), "ToeSegmentation1" => Dict("1" => 128, "0" => 140), "DistalPhalanxTW" => Dict("8" => 254, "4" => 46, "5" => 121, "6" => 43, "7" => 26, "3" => 47), "LargeKitchenAppliances" => Dict("1" => 250, "2" => 250, "3" => 250), "NonInvasiveFetalECGThorax1" => Dict("24" => 87, "29" => 96, "1" => 84, "12" => 90, "32" => 90, "20" => 90, "4" => 85, "2" => 91, "25" => 90, "6" => 94, "23" => 87, "22" => 
86, "11" => 75, "35" => 94, "13" => 97, "41" => 93, "15" => 98, "27" => 89, "31" => 94, "42" => 93, "33" => 85, "28" => 85, "16" => 95, "5" => 96, "14" => 89, "39" => 90, "40" => 91, "21" => 89, "38" => 91, "7" => 93, "34" => 94, "8" => 91, "36" => 91, "26" => 78, "17" => 85, "10" => 92, "19" => 88, "37" => 87, "18" => 91, "9" => 88, "30" => 86, "3" => 87), "Car" => Dict("4" => 30, "1" => 30, "2" => 30, "3" => 30), "RefrigerationDevices" => Dict("1" => 250, "2" => 250, "3" => 250), "ItalyPowerDemand" => Dict("1" => 545, "2" => 547), "MelbournePedestrian" => Dict("8" => 349, "4" => 365, "1" => 365, "10" => 365, "2" => 365, "5" => 365, "6" => 365, "7" => 365, "9" => 364, "3" => 365), "ShapeletSim" => Dict("1" => 100, "0" => 100), "MoteStrain" => Dict("1" => 685, "2" => 587), "Lightning2" => Dict("1" => 73, "-1" => 48))

# multivariate datasets are not yet supported
TSAD_MULTIVARIATE = String[]
